searchNodes=[{"doc":"UltimateTtt is an Elixir module implementing the game Ultimate Tic-Tac-Toe. It implements the core, sequential game logic as well as an OTP app for creating and managing games. If you&#39;re unfamiliar with the game, check out Ultimate Tic-Tac-Toe by Ben Orlin. Links Package: https://hex.pm/packages/ultimate_ttt Documentation: https://hexdocs.pm/ultimate_ttt/ Source: https://github.com/BinaryMuse/ultimate-ttt Installation This package is available on Hex and can be installed by adding ultimate_ttt to your list of dependencies in mix.exs: def deps do [ {:ultimate_ttt, &quot;~&gt; 0.1.0&quot;} ] end Game Rules Ultimate Tic-Tac-Toe is played on a 3x3 grid, where each cell of the grid contains another 3x3 grid. The goal of the game is to win three games of tic-tac-toe in the inner grids such that they form a line in the outer grid. The key rule of the game is that a play must be made in the board associated with the space the previous player played. For example, x starts the game by plying anywhere they want. Here, they choose to play in the middle-left board (index 3) in the center space (index 4): alias UltimateTtt.Game game = Game.new() {:ok, game} = Game.place_tile(game, :x, {3, 4}) │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───────────┼───────────┼─────────── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ x │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───────────┼───────────┼─────────── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ Now, o is required to play somewhere in the board at the center of the outer grid, because x played in the center space in the grid they chose. Similarly, the square they choose to play on in this center board will affect which grid x will be forced to play in next. Game.valid_moves(game, :o) │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───────────┼───────────┼─────────── │ │ │ + │ + │ + │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ x │ │ + │ + │ + │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ + │ + │ + │ │ │ ───────────┼───────────┼─────────── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ If a play forces the next player to play in a board that is either already claimed (by someone winning that board) or is full (resulting in a tie in the board), that player may choose to play anywhere they want. The game is over when a player has won three inner boards in a row, resulting in a win for that player, or when every board is either won or a tie but no player has won three boards in a line, resulting in a tie. Example Core Rules The core rules of Ultimate Tic-Tac-Toe are implemented by the UltimateTtt.Game module. iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; Game.turn(game) :x iex&gt; Game.valid_move?(game, :x, {3, 4}) true iex&gt; {:ok, game} = Game.place_tile(game, :x, {3, 4}) iex&gt; Game.turn(game) :o iex&gt; Game.valid_move?(game, :o, {3, 0}) # Player o has to play in the board at index 4 false iex&gt; Game.valid_move?(game, :x, {4, 0}) # Not player x&#39;s turn false iex&gt; Game.valid_move?(game, :o, {4, 0}) true iex&gt; Game.valid_moves(game, :o) [{4, 0}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8}] iex&gt; Game.status(game) :in_progress iex&gt; Game.last_played_space(game) {3, 4} iex&gt; Game.tile_at(game, {3, 4}) :x iex&gt; Game.tile_at(game, {4, 0}) :empty OTP App (Not yet implemented) game = GameSession.start_link()","ref":"UltimateTtt.html","title":"UltimateTtt","type":"module"},{"doc":"This module implements the core, sequential rules of Ultimate Tic-Tac-Toe. To begin a game, use new/0. Make plays on the board with place_tile/3. alias UltimateTtt.Game game = Game.new() # Place an &quot;x&quot; in the center board, in the top-left square {:ok, game} = Game.place_tile(game, :x, {4, 0}) You can check whether or not a move would be valid for a player using valid_move?/3. Note that this function returns false if it&#39;s not the given player&#39;s turn. (To check if a given move is valid for any player, use board/1 and pass it to UltimateTtt.Game.OuterBoard.valid_move?/2.) You can get a list of all valid moves for a player with valid_moves/2 (or valid moves for any player using UltimateTtt.Game.OuterBoard.valid_moves/1), which can be useful for highlighting valid moves in a UI. Note that no moves are considered valid once the game is over. In this example, since :x just played in the top-left square of a board, :o must now play inside the top-left board, if possible. Game.valid_move?(game, :o, {2, 3}) # false, not in top-left board! Game.valid_move?(game, :x, {0, 3}) # false, not x&#39;s turn! Game.valid_move?(game, :o, {0, 3}) # true Game.valid_moves(game, :o) # [{0, 0}, {0, 1}, {0, 2}, {0, 3}, ...] Finally, you can get an overall status of the game using status/1. The possible return values are :in_progress, :tie, and {:win, player} where player is :x or :o. Game.status(game) # :in_progress","ref":"UltimateTtt.Game.html","title":"UltimateTtt.Game","type":"module"},{"doc":"Return the UltimateTtt.Game.OuterBoard contained within the game.","ref":"UltimateTtt.Game.html#board/1","title":"UltimateTtt.Game.board/1","type":"function"},{"doc":"Returns the space that the most recent move was made in. Examples iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; Game.last_played_space(game) nil iex&gt; {:ok, game} = Game.place_tile(game, :x, {0, 4}) iex&gt; Game.last_played_space(game) {0, 4}","ref":"UltimateTtt.Game.html#last_played_space/1","title":"UltimateTtt.Game.last_played_space/1","type":"function"},{"doc":"Creates a new game. The :x player starts.","ref":"UltimateTtt.Game.html#new/0","title":"UltimateTtt.Game.new/0","type":"function"},{"doc":"Place a new tile. Examples iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; {:ok, game} = Game.place_tile(game, :x, {0, 0}) iex&gt; Game.valid_move?(game, :o, {0, 0}) false","ref":"UltimateTtt.Game.html#place_tile/3","title":"UltimateTtt.Game.place_tile/3","type":"function"},{"doc":"Get the status of the game. Examples iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; Game.status(game) :in_progress","ref":"UltimateTtt.Game.html#status/1","title":"UltimateTtt.Game.status/1","type":"function"},{"doc":"Returns the tile at the given space. Examples iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; Game.tile_at(game, {0, 0}) :empty iex&gt; {:ok, game} = Game.place_tile(game, :x, {0, 0}) iex&gt; Game.tile_at(game, {0, 0}) :x","ref":"UltimateTtt.Game.html#tile_at/2","title":"UltimateTtt.Game.tile_at/2","type":"function"},{"doc":"Return the player who should play the next turn. Examples iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; Game.turn(game) :x iex&gt; {:ok, game} = Game.place_tile(game, :x, {0, 0}) iex&gt; Game.turn(game) :o","ref":"UltimateTtt.Game.html#turn/1","title":"UltimateTtt.Game.turn/1","type":"function"},{"doc":"Determines if the given play is valid. Returns false if it&#39;s not the given player&#39;s turn, even if the move would otherwise be valid. Always returns false once the game is over. Examples iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; Game.valid_move?(game, :x, {0, 0}) true iex&gt; Game.valid_move?(game, :o, {0, 0}) false","ref":"UltimateTtt.Game.html#valid_move?/3","title":"UltimateTtt.Game.valid_move?/3","type":"function"},{"doc":"Get a list of all valid moves for the given player. Will return an empty list if it&#39;s not the given player&#39;s turn, even if some moves would otherwise be valid. No moves are valid once the game is won. Examples iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; moves = Game.valid_moves(game, :x) iex&gt; Enum.count(moves) 81 iex&gt; Game.valid_moves(game, :o) []","ref":"UltimateTtt.Game.html#valid_moves/2","title":"UltimateTtt.Game.valid_moves/2","type":"function"},{"doc":"","ref":"UltimateTtt.Game.html#t:board/0","title":"UltimateTtt.Game.board/0","type":"type"},{"doc":"","ref":"UltimateTtt.Game.html#t:game_status/0","title":"UltimateTtt.Game.game_status/0","type":"type"},{"doc":"An atom representing the player playing &quot;X&quot; or &quot;O&quot;.","ref":"UltimateTtt.Game.html#t:player/0","title":"UltimateTtt.Game.player/0","type":"type"},{"doc":"A tuple of two numbers; the first number represents the index of the board, starting in the top-left cell and moving to the right and then to the left-most cell on the next row, and the second number represents the index of the cell inside that board.","ref":"UltimateTtt.Game.html#t:space/0","title":"UltimateTtt.Game.space/0","type":"type"},{"doc":"","ref":"UltimateTtt.Game.html#t:t/0","title":"UltimateTtt.Game.t/0","type":"opaque"},{"doc":"Represents the data for a single tile in a tic-tac-toe board; can be one of either players or :empty.","ref":"UltimateTtt.Game.html#t:tile/0","title":"UltimateTtt.Game.tile/0","type":"type"},{"doc":"This module represents one of the nine inner tic-tac-toe boards in a game of Ultimate Tic-Tac-Toe. Normally you will not need to interact with this module directly as most of its functionality is exposed through UltimateTtt.Game.OuterBoard. Note that this module does not track player turn, and thus any move into any empty space is valid unless the board is won or tied.","ref":"UltimateTtt.Game.InnerBoard.html","title":"UltimateTtt.Game.InnerBoard","type":"module"},{"doc":"Deserializes a serialized board back into an actual board. Examples iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; InnerBoard.deserialize(&quot;x.......o&quot;) #InnerBoard&lt;&quot;x.......o&quot;&gt;","ref":"UltimateTtt.Game.InnerBoard.html#deserialize/1","title":"UltimateTtt.Game.InnerBoard.deserialize/1","type":"function"},{"doc":"Returns a new, empty board.","ref":"UltimateTtt.Game.InnerBoard.html#new/0","title":"UltimateTtt.Game.InnerBoard.new/0","type":"function"},{"doc":"Attempts to place the given tile on the board at the given space. Examples iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; board = InnerBoard.new() iex&gt; {:ok, board} = InnerBoard.place_tile(board, 0, :x) iex&gt; InnerBoard.place_tile(:board, 0, :o) {:error, :invalid_move}","ref":"UltimateTtt.Game.InnerBoard.html#place_tile/3","title":"UltimateTtt.Game.InnerBoard.place_tile/3","type":"function"},{"doc":"Serializes a board to a string representation. Examples iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; board = InnerBoard.new() iex&gt; {:ok, board} = InnerBoard.place_tile(board, :x, 0) iex&gt; {:ok, board} = InnerBoard.place_tile(board, :o, 8) iex&gt; InnerBoard.serialize(board) &quot;x.......o&quot;","ref":"UltimateTtt.Game.InnerBoard.html#serialize/1","title":"UltimateTtt.Game.InnerBoard.serialize/1","type":"function"},{"doc":"Returns the status of the board. This can be :in_progress, :tie, or {:win, player} (where player is :x or :o). Examples iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; board = InnerBoard.new iex&gt; InnerBoard.status(board) :in_progress iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; board = InnerBoard.deserialize(&quot;x...x...x&quot;) iex&gt; InnerBoard.status(board) {:win, :x}","ref":"UltimateTtt.Game.InnerBoard.html#status/1","title":"UltimateTtt.Game.InnerBoard.status/1","type":"function"},{"doc":"Returns the tile occupying the given space. Examples iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; board = InnerBoard.deserialize(&quot;xo.......&quot;) iex&gt; InnerBoard.tile_at(board, 1) :o iex&gt; InnerBoard.tile_at(board, 2) :empty","ref":"UltimateTtt.Game.InnerBoard.html#tile_at/2","title":"UltimateTtt.Game.InnerBoard.tile_at/2","type":"function"},{"doc":"Returns a boolean specifying whether or not a given move is valid. space must be a number between 0 and 8, inclusive. Examples iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; board = InnerBoard.new() iex&gt; InnerBoard.valid_move?(board, 0) true iex&gt; InnerBoard.valid_move?(board, 9) false iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; board = InnerBoard.deserialize(&quot;.x.ox...o&quot;) iex&gt; InnerBoard.valid_move?(board, 1) false","ref":"UltimateTtt.Game.InnerBoard.html#valid_move?/2","title":"UltimateTtt.Game.InnerBoard.valid_move?/2","type":"function"},{"doc":"Returns a list of numbers that represent all valid moves for the board. No moves are considered valid once the board is won. Examples iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; InnerBoard.valid_moves(InnerBoard.new) [0, 1, 2, 3, 4, 5, 6, 7, 8] iex&gt; alias UltimateTtt.Game.InnerBoard iex&gt; &quot;.x.ox...o&quot; ...&gt; |&gt; InnerBoard.deserialize() ...&gt; |&gt; InnerBoard.valid_moves() [0, 2, 5, 6, 7]","ref":"UltimateTtt.Game.InnerBoard.html#valid_moves/1","title":"UltimateTtt.Game.InnerBoard.valid_moves/1","type":"function"},{"doc":"","ref":"UltimateTtt.Game.InnerBoard.html#t:board_status/0","title":"UltimateTtt.Game.InnerBoard.board_status/0","type":"type"},{"doc":"","ref":"UltimateTtt.Game.InnerBoard.html#t:player/0","title":"UltimateTtt.Game.InnerBoard.player/0","type":"type"},{"doc":"","ref":"UltimateTtt.Game.InnerBoard.html#t:space/0","title":"UltimateTtt.Game.InnerBoard.space/0","type":"type"},{"doc":"","ref":"UltimateTtt.Game.InnerBoard.html#t:t/0","title":"UltimateTtt.Game.InnerBoard.t/0","type":"opaque"},{"doc":"","ref":"UltimateTtt.Game.InnerBoard.html#t:tile/0","title":"UltimateTtt.Game.InnerBoard.tile/0","type":"type"},{"doc":"This module represents the larger, outer tic-tac-toe grid containing 9 inner tic-tac-toe grids (which are in turn represented by UltimateTtt.Game.InnerBoard). Normally you will not need to interact with this module directly as most of its functionality is exposed through UltimateTtt.Game. Note that this module does not track player turn, nor does it it implement the rules restricting play to the board associated with the last played space, and thus any move into any empty space is valid unless the board is won or tied.","ref":"UltimateTtt.Game.OuterBoard.html","title":"UltimateTtt.Game.OuterBoard","type":"module"},{"doc":"Deserializes a serialized board back into an actual board.","ref":"UltimateTtt.Game.OuterBoard.html#deserialize/1","title":"UltimateTtt.Game.OuterBoard.deserialize/1","type":"function"},{"doc":"Returns the UltimateTtt.Game.InnerBoard stored at the given index.","ref":"UltimateTtt.Game.OuterBoard.html#inner_board_at/2","title":"UltimateTtt.Game.OuterBoard.inner_board_at/2","type":"function"},{"doc":"Returns a new, empty board.","ref":"UltimateTtt.Game.OuterBoard.html#new/0","title":"UltimateTtt.Game.OuterBoard.new/0","type":"function"},{"doc":"Attempts to place the given tile on the given board at the given space. Returns {:ok, new_board} if successful and {:err, :invalid_move} otherwise. The move is specified as {board_idx, space_idx}.","ref":"UltimateTtt.Game.OuterBoard.html#place_tile/3","title":"UltimateTtt.Game.OuterBoard.place_tile/3","type":"function"},{"doc":"Serializes a board to a string representation","ref":"UltimateTtt.Game.OuterBoard.html#serialize/1","title":"UltimateTtt.Game.OuterBoard.serialize/1","type":"function"},{"doc":"Returns the status of the board. This can be :in_progress, :tie, or {:win, player} (where player is :x or :o).","ref":"UltimateTtt.Game.OuterBoard.html#status/1","title":"UltimateTtt.Game.OuterBoard.status/1","type":"function"},{"doc":"Returns the UltimateTtt.Game.tile/0 at the given space. Examples iex&gt; alias UltimateTtt.Game.OuterBoard iex&gt; board = OuterBoard.new() iex&gt; OuterBoard.tile_at(board, {0, 0}) :empty iex&gt; {:ok, board} = OuterBoard.place_tile(board, :x, {0, 0}) iex&gt; OuterBoard.tile_at(board, {0, 0}) :x","ref":"UltimateTtt.Game.OuterBoard.html#tile_at/2","title":"UltimateTtt.Game.OuterBoard.tile_at/2","type":"function"},{"doc":"Determines if the given move is valid for the board. The move is specified as {board_idx, space_idx}. Example iex&gt; alias UltimateTtt.Game.OuterBoard iex&gt; board = OuterBoard.new() iex&gt; OuterBoard.valid_move?(board, {0, 0}) true iex&gt; {:ok, board} = OuterBoard.place_tile(board, :x, {0, 0}) iex&gt; OuterBoard.valid_move?(board, {0, 0}) false","ref":"UltimateTtt.Game.OuterBoard.html#valid_move?/2","title":"UltimateTtt.Game.OuterBoard.valid_move?/2","type":"function"},{"doc":"Returns a list of all spaces representing valid moves on the board. No moves are considered valid once the board is won.","ref":"UltimateTtt.Game.OuterBoard.html#valid_moves/1","title":"UltimateTtt.Game.OuterBoard.valid_moves/1","type":"function"},{"doc":"An opaque data structure representing the larger, outer tic-tac-toe grid.","ref":"UltimateTtt.Game.OuterBoard.html#t:t/0","title":"UltimateTtt.Game.OuterBoard.t/0","type":"opaque"},{"doc":"Elixir Ultimate Tic-Tac-Toe UltimateTtt is an Elixir module implementing the game Ultimate Tic-Tac-Toe. It implements the core, sequential game logic as well as an OTP app for creating and managing games. If you&#39;re unfamiliar with the game, check out Ultimate Tic-Tac-Toe by Ben Orlin.","ref":"readme.html","title":"README.md","type":"extras"},{"doc":"Package: https://hex.pm/packages/ultimate_ttt Documentation: https://hexdocs.pm/ultimate_ttt/ Source: https://github.com/BinaryMuse/ultimate-ttt","ref":"readme.html#links","title":"README.md - Links","type":"extras"},{"doc":"This package is available on Hex and can be installed by adding ultimate_ttt to your list of dependencies in mix.exs: def deps do [ {:ultimate_ttt, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"README.md - Installation","type":"extras"},{"doc":"Ultimate Tic-Tac-Toe is played on a 3x3 grid, where each cell of the grid contains another 3x3 grid. The goal of the game is to win three games of tic-tac-toe in the inner grids such that they form a line in the outer grid. The key rule of the game is that a play must be made in the board associated with the space the previous player played. For example, x starts the game by plying anywhere they want. Here, they choose to play in the middle-left board (index 3) in the center space (index 4): alias UltimateTtt.Game game = Game.new() {:ok, game} = Game.place_tile(game, :x, {3, 4}) │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───────────┼───────────┼─────────── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ x │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───────────┼───────────┼─────────── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ Now, o is required to play somewhere in the board at the center of the outer grid, because x played in the center space in the grid they chose. Similarly, the square they choose to play on in this center board will affect which grid x will be forced to play in next. Game.valid_moves(game, :o) │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───────────┼───────────┼─────────── │ │ │ + │ + │ + │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ x │ │ + │ + │ + │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ + │ + │ + │ │ │ ───────────┼───────────┼─────────── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ ───┼───┼───│───┼───┼───│───┼───┼─── │ │ │ │ │ │ │ │ If a play forces the next player to play in a board that is either already claimed (by someone winning that board) or is full (resulting in a tie in the board), that player may choose to play anywhere they want. The game is over when a player has won three inner boards in a row, resulting in a win for that player, or when every board is either won or a tie but no player has won three boards in a line, resulting in a tie.","ref":"readme.html#game-rules","title":"README.md - Game Rules","type":"extras"},{"doc":"Core Rules The core rules of Ultimate Tic-Tac-Toe are implemented by the UltimateTtt.Game module. iex&gt; alias UltimateTtt.Game iex&gt; game = Game.new() iex&gt; Game.turn(game) :x iex&gt; Game.valid_move?(game, :x, {3, 4}) true iex&gt; {:ok, game} = Game.place_tile(game, :x, {3, 4}) iex&gt; Game.turn(game) :o iex&gt; Game.valid_move?(game, :o, {3, 0}) # Player o has to play in the board at index 4 false iex&gt; Game.valid_move?(game, :x, {4, 0}) # Not player x&#39;s turn false iex&gt; Game.valid_move?(game, :o, {4, 0}) true iex&gt; Game.valid_moves(game, :o) [{4, 0}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8}] iex&gt; Game.status(game) :in_progress iex&gt; Game.last_played_space(game) {3, 4} iex&gt; Game.tile_at(game, {3, 4}) :x iex&gt; Game.tile_at(game, {4, 0}) :empty OTP App (Not yet implemented) game = GameSession.start_link()","ref":"readme.html#example","title":"README.md - Example","type":"extras"}]